package pnews.servlet;

import java.util.logging.Level;
import java.util.logging.Logger;

import com.google.gson.Gson;
import com.google.gson.JsonObject;

import pnews.Article;
import pnews.Category;

public class JSON {
        private static final Logger LOG = Logger.getLogger(JSON.class.getName());
        
        public static String getStats(Category[] cats) {
                JsonObject jstats, jreadcounts, jcategories, jmemory;
                Runtime runtime;
                Article[] articles;
                
                jstats = new JsonObject();
                                
                jstats.addProperty("articles-count", ArticleStore.singleton.size());
                
                jreadcounts = new JsonObject();
                jstats.add("read-counts", jreadcounts);
                
                articles = ArticleStore.singleton.getArticles();
                for (Article a: articles)
                        if (a.readCount.get() > 0)
                                jreadcounts.addProperty(a.link, a.readCount);         
                
                jcategories = new JsonObject();
                jstats.add("categories", jcategories);
                
                for (Category cat: cats)
                        try {
                                jcategories.addProperty(cat.getLabel(),
                                                        articles.length);
                        } catch (IllegalArgumentException e) {
                                LOG.log(Level.SEVERE, "Fail to retrieve articles", e);
                        }
                
                jmemory = new JsonObject();
                jstats.add("memory", jmemory);
                
                runtime = Runtime.getRuntime();
                jmemory.addProperty("total", runtime.totalMemory());
                jmemory.addProperty("max", runtime.maxMemory());
                jmemory.addProperty("free", runtime.freeMemory());
                
                return new Gson().toJson(jstats);                
        }
}
